import java.io.PrintWriter;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.io.IOException;

/**
 * Menu ubicado en la ventana de la aplicacion
 */
public class MenuBar extends JMenuBar{

/**
 * Constructor del menu
 * Agrega los submenus necesarios para cargar un programa y modificar la velocidad
 * @param h Cabezal de la maquina
 */
    public MenuBar(Head h) {
        JMenu menu;
        JMenu submenu;
        JMenuItem menuItem;

        final CreateWindow window = new CreateWindow(h);

        head = h;

        menu = new JMenu("Cargar Programa");
        add(menu);

        submenu = new JMenu("Ejemplos");
        menu.add(submenu);

        menuItem = new JMenuItem("Palindromo binario");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                head.Compile("Examples/BinaryPalindrome.txt","file");
            }
        });
        submenu.add(menuItem);

        menuItem = new JMenuItem("Divisible por 3");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                head.Compile("Examples/DivisibleBy3.txt","file");
            }
        });
        submenu.add(menuItem);

        menuItem = new JMenuItem("Crear");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                window.setVisible(true);
            }
        });
        menu.add(menuItem);

        menu = new JMenu("Opciones");
        add(menu);

        menuItem = new JMenuItem("Velocidad");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String stringspeed = JOptionPane.showInputDialog("Set the speed");
                if (stringspeed != null) {
                    try {
                        float speed = Float.parseFloat(stringspeed);
                        head.SetSpeed(speed);
                    } catch (NumberFormatException exception){
                        actionPerformed(e);
                    }
                }
            }
        });
        menu.add(menuItem);
    }

    private Head head;
}

/**
 * Ventana en la cual se crean los programa ingresados por el usuario
 */
class CreateWindow extends JFrame {
    public CreateWindow(Head h) {
        setTitle("Create Program");
        setSize(280,400);
        CreatePanel panel = new CreatePanel(this,h);

        Container contentPane = getContentPane();
        contentPane.add(panel);
    }
}

class CreatePanel extends JPanel {
    public CreatePanel(final CreateWindow w, Head h) {
        window = w;
        head = h;

        label = new JLabel("Initial state: ");
        add(label);

        initialState = new JTextField(20);
        add(initialState);

        label = new JLabel("Acceptng States:");
        add(label);

        acceptngStates = new JTextField(20);
        add(acceptngStates);

        label = new JLabel("States:");
        add(label);
        label = new JLabel("(?)");
        label.setToolTipText("<html>NameState1<br>Condition1,WriteSymbol,Move,NextState<br>Condition2,WriteSymbol,Move,NextState<br>...<br>NameState2<br>...</html>");
        add(label);

        textArea = new JTextArea(15,20);
        JScrollPane scrollPane = new JScrollPane(textArea);
        //final PrintWriter writer;

        loadButton = new JButton("Cargar");
        loadButton.addActionListener( new ActionListener (){
            public void actionPerformed(ActionEvent event) {
                head.Compile(textArea.getText()+"\n\n"+initialState.getText()+"\n"+acceptngStates.getText(),"string");
                w.setVisible(false);
            };
        });

        add(scrollPane);
        add(loadButton);
    }

    private Head head;
    private CreateWindow window;
    private JTextArea textArea;
    private JButton loadButton;
    private JLabel label;
    private JTextField initialState;
    private JTextField acceptngStates;
}
