import java.util.ArrayList;

/**
 * Representa un estado que puede adoptar la maquina
 * Se compone de una lista de instrucciones
 */
class State{

/**
 * Constructor del estado
 * @param n Nombre ddel estado
 * @param is Lista de las instrucciones
 */
	public State(String n, ArrayList<Instruction> is) {
		name = n;
        instructions = (ArrayList) is.clone();
	}

/**
 * Busca el la instruccion del estado correspondiente al simbolo leido por el cabezal
 * @param c Simbolo leido por el cabezal
 * @return Instruccion correspondiente
 */
	public Instruction GetInstructions(String c) {
		for (int i = 0; i < instructions.size(); i++) {
			if (instructions.get(i).GetValue().equals(c)) {
				return instructions.get(i);
			}
		}
		return null;
	}

	public String GetName() {
		return name;
	}

/**
 * Transforma el estado en un string
 * @return estado como string
 */
	public String toString() {
		String s = "";
		for (int i = 0; i < instructions.size(); i++) {
			s+=instructions.get(i);
			s+="\n";
		}
		return s;
	}

	private String name;

	private ArrayList<Instruction> instructions;
}